<?php
/*
OekakiBBS parse code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wacintaki Poteto modifications Copyright 2004-2006 Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 1.3.0 - Last modified 4/24/2006
*/


/*
NOTES:

OekakiBBS dosn't transmit CGI headers, so we read GET data instead, as explained in oekakiBBS.php.

Special error reporting is needed, because errors are return codes sent to the applet, not a web browser.

*/


function quiet_exit($exit_err) {
	global $dbconn;
	@mysql_close ($dbconn);

	header ('Content-type: text/plain');
	exit ($exit_err);
}


if (empty ($HTTP_RAW_POST_DATA)) {
	// No data to save!
	quiet_exit("No image data was received by the server.\nPlease try again, or take a screenshot of your picture.");
}


// Load bootstrap, quiet mode
if (!get_magic_quotes_gpc()) {
	$OekakiU    = addslashes ($_GET['usr']);
	$OekakiPass = addslashes ($_GET['vcode']);
} else {
	set_magic_quotes_runtime(0);
	$OekakiU    = $_GET['usr'];
	$OekakiPass = $_GET['vcode'];
}
if (empty ($OekakiU)) {
	quiet_exit('Login could not be verified!  Take a screenshot of your picture.');
}
$quiet_mode = 1;
define ('BOOT', 1);
require ('boot.php');
require ('paintsave.php');

// Clean input
$mode      = $_GET['mode'];
$edittimes = (int) $_GET['edittimes'];
$edit      = (int) $_GET['edit'];
$import    = (int) $_GET['import'];
$user_pass = slashit($_GET['pw']); // Encoded with make_edit_pass()


// Collect POST
$start  = strpos ($HTTP_RAW_POST_DATA, 'Content-type:');
$middle = 0;
$end    = 0;

while ($start) {
	// Foreach Content-type, get type
	$end    = strpos ($HTTP_RAW_POST_DATA, 'Content-type:', $start + 1);
	$middle = strpos ($HTTP_RAW_POST_DATA, "\r", $start);
	$type   = substr ($HTTP_RAW_POST_DATA, $start + 13, $middle - $start - 13 );
	$middle = strpos ($HTTP_RAW_POST_DATA, "\r", $middle + 1);

	if ($end === FALSE) {
		$end = NULL;
		$data = substr ($HTTP_RAW_POST_DATA, $middle + 2);
	} else {
		$data = substr ($HTTP_RAW_POST_DATA, $middle + 2, $end-$middle - 2);
	}

	$start = $end;

	// 'image/0'=PNG, 'image/1'=JPEG
	if ($type == 'image/0' || $type == 'image/1') {
		$picturedata = $data;
	}
	if ($type == 'animation/') {
		$animdata = $data;
	}

	unset ($data);
}


// Insert new slot into database
if ($mode == 'norm' || $mode == 'anim') {
	$resno = get_new_picnumber();
	if ($resno == 0) {
		error_log (__FILE__.": Cannot allocate new PIC_ID.  User: $OekakiU");
		quiet_exit("Unable to allocate a new picture slot!\nTake a screenshot of your picture and tell the admin.");
	}

	// Cleanup slots
	$result = clean_picture_slots();

	$thetime = time() - $edittimes;

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$sqlres = "INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='$OekakiU', postdate=NOW(), hostname='$hostname', comment='', PIC_ID='$resno', IP='$address', datatype=1, edittime='$thetime', password=''";
		if ($mode == 'anim') {
			$sqlres .= ', animation=1';
		} else {
			$sqlres .= ', animation=0';
		}
		$result = mysql_query ($sqlres);

		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		error_log (__FILE__.": DB cannot save image.  User: $OekakiU, Number: $resno, SQL: ".mysql_error());
		quiet_exit("Unable to save image.\nPlease try again, or take a screenshot of your picture.");
	}
}


// Update edited slot to database
if ($mode == 'edit') {
	// Verify edit, otherwise invalidate it
	$resno = verify_edit($edit, $user_pass);

	$edittime2 = time() - $edittimes;
	$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");
}


// Write files
//
// Save image/anim data.  Filetype is automatic!
if (!save_image($picturedata, $resno)) {
	error_log (__FILE__.": Cannot save image.  Look for temp image.  User: $OekakiU, Number: $resno");
	quiet_exit("Unable to save image.\nPlease try again, or take a screenshot of your picture.");
}
if (!empty ($animdata)) {
	save_anim($animdata, $resno, 'oeb');
}


// Credit original artist, if required
if ($import) {
	$result = mysql_query ("SELECT usrname, origart FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='{$import}'");

	if ($result && mysql_num_rows ($result) > 0) {
		$import_check = mysql_fetch_array ($result);
		$import_check['usrname'] = addslashes ($import_check['usrname']);
		$import_check['origart'] = addslashes ($import_check['origart']);

		if ($import_check['usrname'] != $OekakiU) {
			// Not artist!  We'll need to update 'origart'.

			if ($import_check['origart'] != $OekakiU) {
				// Not original artist, either.  Update.
				$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET origart='{$import_check['usrname']}' WHERE PIC_ID='{$resno}'");
			} else {
				// Retouched by original artist.  Clear 'origart' if set
				$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET origart='' WHERE PIC_ID='{$resno}'");
			}
		}
	}
}


@mysql_close ($dbconn);

?>