<?php
/*
Animation code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wacintaki Poteto modifications Copyright 2004-2006 Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 1.3.0 - Last modified 4/24/2006
*/


/*
NOTES:

Cookies don't [aren't supposed to] work with POST, so we get $OekakiU from applet and load boot.php later.  All variables end up in keyed array $params.  We process that first before adding the bootstrap.  Note that everything comes from CGI, so addslashes() as needed!

Special error reporting is needed, because errors are return codes sent to the applet, not a web browser.

*/


// Error reporting
function print_ok() {
	global $dbconn;
	@mysql_close ($dbconn);

	header('Content-type: text/plain');
	exit ('ok');
}
function quiet_exit($exit_err) {
	global $dbconn;
	@mysql_close ($dbconn);

	header ('Content-type: text/plain');
	echo "error\n";
	exit ($exit_err);
}


if (empty ($HTTP_RAW_POST_DATA)) {
	// No data to save!
	quiet_exit("No image data was received by the server.\nPlease try again, or take a screenshot of your picture.");
}

if (substr ($HTTP_RAW_POST_DATA, 0, 1) == 'P') {
	// Header
	$image['h_length'] = substr ($HTTP_RAW_POST_DATA, 1, 8);
	$image['h_length'] = (int) $image['h_length'];
	$image['h_data']   = substr ($HTTP_RAW_POST_DATA, 9, $image['h_length']);

	$params = array ();
	$pairs = explode(';', $image['h_data']);
	for ($i = count ($pairs); --$i >= 0;) {
		$keyvals = explode ('=', $pairs[$i]);
		$params[$keyvals[0]] = $keyvals[1];
	}
} else {
	quiet_exit("Poo compatibility with PaintBBS must be OFF!\n  Admin: set '<param name=\"poo\" value=\"false\" />'");
}


// Load bootstrap, quiet mode
$OekakiU    = addslashes ($params['usr']);
$OekakiPass = addslashes ($params['vcode']);
if (empty ($OekakiU)) {
	quiet_exit('Login could not be verified!  Take a screenshot of your picture.');
}
$quiet_mode = 1;
define ('BOOT', 1);
require ('boot.php');
require ('paintsave.php');

// Clean input
$mode      = $params['mode'];
$edittimes = (int) $params['edittimes'];
$edit      = (int) $params['edit'];
$import    = (int) $params['import'];
$user_pass = $params['pw']; // Encoded with make_edit_pass()


// PaintBBS data
if (substr ($HTTP_RAW_POST_DATA, 0, 1) == 'P') {
	// Image data
	$image['o_length'] = substr ($HTTP_RAW_POST_DATA, $image['h_length'] + 9, 8);
	$image['o_length'] = (int) $image['o_length'];
	$image['o_data']   = substr ($HTTP_RAW_POST_DATA, $image['h_length'] + 19, $image['o_length']);

	// Animation
	$image['t_length'] = substr ($HTTP_RAW_POST_DATA, $image['h_length'] + $image['o_length'] + 19, 8);
	$image['t_length'] = (int) $image['t_length'];
	$image['t_data']   = substr ($HTTP_RAW_POST_DATA, $image['h_length'] + $image['o_length'] + 27, $image['t_length']);

	// Thumbnail
	$image['t2_length'] = substr ($HTTP_RAW_POST_DATA, $image['h_length'] + $image['o_length'] + $image['t_length'] + 27, 8);
	$image['t2_length'] = (int) $image['t2_length'];
	$image['t2_data']   = substr ($HTTP_RAW_POST_DATA, $image['h_length'] + $image['o_length'] + $image['t_length'] + 35, $image['t2_length']);
}

if (empty ($image['o_data'])) {
	error_log (__FILE__.": No image data.  User: $OekakiU");
	quiet_exit("No data was received!  Take a screenshot of your picture (to be safe), and try submitting it again.");
}


// Insert new slot into database
if ($mode == 'norm' || $mode == 'anim') {
	$resno = get_new_picnumber();
	if ($resno == 0) {
		error_log (__FILE__.": Cannot allocate new PIC_ID.  User: $OekakiU");
		quiet_exit("Unable to allocate a new picture slot!\nTake a screenshot of your picture and tell the admin.");
	}

	// Cleanup slots
	$result = clean_picture_slots();

	$thetime = time() - $edittimes;

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$sqlres = "INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='$OekakiU', postdate=NOW(), hostname='$hostname', comment='', PIC_ID='$resno', IP='$address', datatype=0, edittime='$thetime', password=''";
		if ($mode == 'anim') {
			$sqlres .= ', animation=1';
		} else {
			$sqlres .= ', animation=0';
		}
		$result = mysql_query ($sqlres);

		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		error_log (__FILE__.": DB cannot save image.  User: $OekakiU, Number: $resno, SQL: ".mysql_error());
		quiet_exit("Unable to save image.\nPlease try again, or take a screenshot of your picture.");
	}
}


// Update edited slot to database
if ($mode == 'edit') {
	// Verify edit, otherwise invalidate it
	$resno = verify_edit($edit, $user_pass);

	$edittime2 = time() - $edittimes;
	$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");
}


// Write files
//
// Save image/anim data.  Filetype is automatic!
if (!save_image($image['o_data'], $resno)) {
	error_log (__FILE__.": Cannot save image.  Look for temp image.  User: $OekakiU, Number: $resno");
	quiet_exit("Unable to save image.\nPlease try again, or take a screenshot of your picture.");
}
if (!empty ($image['t_data'])) {
	save_anim($image['t_data'], $resno, 'pch');
}


// Credit original artist, if required
if ($import) {
	$result = mysql_query ("SELECT usrname, origart FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='{$import}'");

	if ($result && mysql_num_rows ($result) > 0) {
		$import_check = mysql_fetch_array ($result);
		$import_check['usrname'] = addslashes ($import_check['usrname']);
		$import_check['origart'] = addslashes ($import_check['origart']);

		if ($import_check['usrname'] != $OekakiU) {
			// Not artist!  We'll need to update 'origart'.

			if ($import_check['origart'] != $OekakiU) {
				// Not original artist, either.  Update.
				$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET origart='{$import_check['usrname']}' WHERE PIC_ID='{$resno}'");
			} else {
				// Retouched by original artist.  Clear 'origart' if set
				$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET origart='' WHERE PIC_ID='{$resno}'");
			}
		}
	}
}


print_ok();

?>