<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2006 Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 1.3.0 - Last modified 4/24/2006
*/


/*
NOTES:
	if (image_jpeg == true):
	Compress level of 1-2 is archival, 4 starts showing artifacts.  3-4 recommended.  0 not recommended due to lossless JPEG (use PNG instead).  Anything over 10 not recommended except for thumbnails.  Max value may be 100 if you hate your artists.  :)

	if (image_jpeg == false):
	ShiPainter employs lossy PNG, and will *completely destroy* quality if you're not careful!  Level should be 0 if image_jpeg is false.  Anything higher than 5 will ruin airbrushing and gradients.

	ShiPainter superimposes animations on top of pictures when retouching.  Unlike PaintBBS, which may take both image and animation data, make sure ShiPainter is given only one type of canvas, or else airbrushed/antialiased images will suffer from incorrect colors and possibly multiple images.

	if (new pic) {
		Send nothing to comment.php.
	} elseif (public edit by new artist) {
		Send import to comment.php.
	} else {
		send edit and import.
	}
*/


// Load bootstrap
$OekakiU    = $_COOKIE['OekakiU'];
$OekakiPass = $_COOKIE['OekakiPass'];
define ('BOOT', 1);
require ('boot.php');
include ('paintsave.php');

// Input
$xcord  = (int) $_GET['xcord'];
$ycord  = (int) $_GET['ycord'];
$anim   = (int) $_GET['anim'];
$edit   = (int) $_GET['edit'];
$tools  = $_GET['tools'];
$cursor = $_GET['cursor'];
$user_pass = slashit($_GET['pw']); // Encoded with make_edit_pass()

// Init
$app_head     = ''; // Passed to save tool
$app_head_pw  = ''; // Added to $app_head
$app_url_exit = ''; // Params for index (comment)
$import       = ''; // Canvas number to import.  Passed to save tool
$app_import   = ''; // Canvas/anim filename to import (based on $anim)
$anim_type    = 'pch'; // Extension for animation

// Shi Specific
if ($tools != 'pro') {
	$tools = 'normal';
}
if ($tools == 'pro') {
	$datatype = 3;
} else {
	$datatype = 2;
}


// Bug in Mac version of Java requires hard-coded values, rather than CSS.  >:(
// Typical viewable width of 800x600 browser is 740px.
	$xhack = '740';
// Typical height
	$yhack = '550';


// Check Draw access
if (!$flags['D']) {
	report_err('You do not have draw access. Login to draw, or ask an administrator for details about receiving access.');
}

// Check anim access
// If retouch, anim flag is ignored
if (!$flags['M']) {
	$anim = 0;
}

if ($edit) {
	// Get pic info
	$result = mysql_query ("SELECT PIC_ID, usrname, animation, password, ptype FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$edit'");
	$row = mysql_fetch_array ($result);

	// Verify anim
	if ($row['animation'] == 1) {
		$anim = 1;
	} else {
		$anim = 0;
	}

	// Set up import
	$import = $edit;
	if ($anim) {
		$app_import = $p_pic.$import.'.'.$anim_type;
	} else {
		$app_import = $p_pic.$import.'.'.$row['ptype'];
	}

	// Choose pass/public retouch option
	if ($row['usrname'] != $OekakiU) {
		$enc_pass = make_edit_pass($row['password']);
		if ($enc_pass == $user_pass) {
			// Password retouch
			// Due to technical/admin issues, only in-place edits are supported
			$app_head_pw = ';pw='.$enc_pass;
		} elseif ($row['password'] == 'public') {
			if ($cfg['public_retouch'] == 'yes') {
				// Public, treat as new pic, but import canvas/anim
				unset ($edit);
			} else {
				// pw != public, and public disabled
				report_err('Public retouch disabled.');
			}
		} else {
			// Invalid!
			report_err('Incorrect password to retouch!');
		}
	}
	$size = GetImageSize ($p_pic.$row['PIC_ID'].'.'.$row['ptype']);
	$xcord = $size[0];
	$ycord = $size[1];
} else {
	// Check for unfinished pictures
	$result = mysql_query ("SELECT COUNT(PIC_ID) FROM {$OekakiPoteto_Prefix}oekakidta WHERE postlock=0 AND usrname='$OekakiU'");
	$num_rows = (int) mysql_result ($result, 0);

	if ($num_rows > 0) {
		// Unfinished pictures interface
		report_err('You have an unfinished picture!');
	}
}


// Verify that canvas sizes fit min/max
if ($xcord > $cfg['canvas_x']) {
	$xcord = $cfg['canvas_x'];
}
if ($ycord > $cfg['canvas_y']) {
	$ycord = $cfg['canvas_y'];
}


// See notes above about compress_level
// APPLET_NO_JPEG is in hacks.php
$image_jpeg_value = (APPLET_NO_JPEG != 0) ? 'false' : 'true';
$image_compress = (APPLET_NO_JPEG != 0) ? '0' : '4';
$image_size_value = applet_image_size_param($xcord, $ycord);


// Set up applet header
if ($edit) {
	$app_head_mode = 'edit';
} elseif ($anim) {
	$app_head_mode = 'anim';
} else {
	$app_head_mode = 'norm';
}
$app_head = "mode={$app_head_mode};edittimes=".time().";usr={$OekakiU};vcode={$OekakiPass};datatype={$datatype};{$app_head_pw}";
if ($edit) {
	$app_head .= ";edit={$edit}";
}
if ($import) {
	$app_head .= ";import={$import}";
}

// Set up applet exit
$app_url_exit = 'comment.php?mode=res_msg';
if ($import && !$edit) {
	$app_url_exit .= "&import={$import}";
} elseif ($import) {
	$app_url_exit .= "&import={$import}&edit={$edit}";
}


// No footer
mysql_close ($dbconn);



/* START HTML */
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title><?=$cfg['op_title']?></title>
	<meta http-equiv="content-type" content="text/html; charset=<?=$charset?>">
	<meta http-equiv="content-language" content="<?=$metatag_language?>">

	<link rel="stylesheet" type="text/css" href="<?=$cssinclude?>" title="<?=$template_name?>">

	<script language="JavaScript" type="text/javascript" src="Poteto.js">
	</script>
</head>

<body>


<div style="text-align: center;">
	<applet id="shibbs"
		code="c.ShiPainter.class"
		archive="spainter_all.jar"
		width="<?=$xhack?>"
		height="<?=$yhack?>"
		mayscript>

		<param name="image_width" value="<?=$xcord?>" />
		<param name="image_height" value="<?=$ycord?>" />

		<param name="dir_resource" value="./shipainter" />
		<param name="tt.zip" value="tt_def.zip" />
		<param name="res.zip" value="res.zip" />
		<param name="tools" value="<?=$tools?>" />
		<param name="layer_count" value="5" />
		<param name="MAYSCRIPT" value="true" />
		<param name="scriptable" value="true" />
<? if ($cursor) { ?>
		<param name="cursor_1" value="<?=$cursor?>.gif" />
<? } ?>

		<param name="image_jpeg" value="<?=$image_jpeg_value?>" />
		<param name="image_size" value="<?=$image_size_value?>" />
		<param name="compress_level" value="<?=$image_compress?>" />

		<param name="url_save" value="shiget.php" />
		<param name="url_exit" value="<?=$app_url_exit?>" />
<?
// Import canvas.  Import only one!
if ($import) {
	if ($anim) {
?>
		<param name="pch_file" value="<?= $p_pic.$import.'.pch'; ?>" />
<?
	} else {
?>
		<param name="image_canvas" value="<?= $p_pic.$import.'.'.$row['ptype']; ?>" />
<?
	}
}
if ($anim) { ?>
		<param name="thumbnail_type" value="animation" />
<? } ?>
		<param name="url_target" value="_self" />

		<param name="undo" value="90" />
		<param name="undo_in_mg" value="15" />

		<param name="poo" value="false" />
		<param name="send_header" value="<?=$app_head?>" />
		<param name="send_header_image_type" value="false" />

		<param name="color_text" value="#000000" />
		<param name="color_bk" value="#aeaed9" />
		<param name="color_bk2" value="#a3a3cc" />
		<param name="color_icon" value="#ccccff" />

		<param name="send_advance" value="true" />
		<param name="send_language" value="utf8" />
	</applet>
</div>

<p style="text-align: center;">
	<input onclick="maximize_app('shibbs');" type="button" value="Resize ShiPainter to fit window" class="submit" />
</p>


<!-- Controls -->
<div class="pheader">
	Applet Controls
</div>

<table class="pinfotable" style="width: 100%; text-align: center;">
	<tr>
	<td style="width: 50%;">
		<p>
			<strong>Please note:</strong>
		</p>
		<ul>
			<li>Any canvas size change will destroy your current picture!</li>
			<li>You cannot resize your canvas when retouching an older picture.</li>
			<li>You may need to refresh the window to start retouching.</li>
			<li>Use the <strong>PRINT SCRN</strong> key regularly! &nbsp;<code>;)</code></li>
		</ul>
	</td>

<? if (!$edit) { ?>
	<td style="width: 50%;">
		<form name="form1" method="get" action="shiBBS.php">
			<p>
				<?=$langop_applet_modify?>
				( <?=$langop_applet_max?> <?=$cfg['canvas_x']?> &times; <?=$cfg['canvas_y']?> )
			</p>

			<p>
				X: <input type="text" name="xcord" value="<?=$xcord?>" class="ptxtinput" /><br />
				Y: <input type="text" name="ycord" value="<?=$ycord?>" class="ptxtinput" /><br />
			</p>

			<input name="tools" type="hidden" value="<?=$tools?>" />
			<input name="cursor" type="hidden" value="<?=$cursor?>" />
<? if ($anim) { ?>
			<input name="anim" type="hidden" value="<?=$anim?>" />
<? } ?>
			<input type="submit" name="Submit" value="Modify" class="submit" />
		</form>
	</td>
<? } ?>
	</tr>
</table>
<br />


<!-- Info -->
<div class="pheader">
	Java Information
</div>

<div class="pinfotable">
	<p style="text-align: center; padding: 0 20% 0 20%;">
		If you're having trouble with the applet, try downloading the latest version of Java from <a href="http://www.Java.com">www.Java.com</a>.  Older versions of Windows are based on the Microsoft Virtual Machine (a Java clone), and may not work very well.
	</p>
</div>
<br />


</body>
</html>