<?php // Include only
if (!defined ('BOOT')) exit ('No bootstrap.  Exiting.');
define ('domainstat', 'ok'); // Avoid DomainStat.net worm

/*
Wacintaki Poteto User Authorization Script
Copyright 2005-2006 Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 1.3.1 - Last modified 5/10/2006

Requires: $_DB, $_CFG, $OekakiU, $OekakiPass

Note:  Do not print anything in $quiet_mode unless it's a security problem, or else applets will freak out.  Just flush everything or use error_log().
*/


/* ===================================================================
// Init
//
	BAN_OVERRIDE // Set 1 in hacks.php to disable ban list
	BAN_KILL     // Set 1 to disable ban list
	$no_template // Set 1 to avoid including template
	$no_online   // Set 1 to disable online check
	$quiet_mode  // Set 1 to disable mostly everything (for paint applets)
*/
define ('BAN_KILL', 0);
$no_template = FALSE;
$no_online = FALSE;
$quiet_mode = FALSE;

$mode = '';
$action = '';
if (isset ($_GET['mode']))
	$mode = $_GET['mode'];
if (isset ($_REQUEST['action']))
	$action = $_REQUEST['action'];

// ===================================================================
// Defines
//
$version       = '1.3.1'; // Formats:  M.m or M.m.r
$mod_version   = 'wac';   // Type your mod name here
$cfg_ver_check = '1.3.0'; // Config version required
$cfg_db_check  = '1.3.0'; // DB version required

$user  = array(); // SQL user data
$flags = array(); // Permission flags
$flags['member'] = 0; // Is a registered member
$flags['mod']    = 0; // Is a moderator
$flags['admin']  = 0; // Is an admin
$flags['sadmin'] = 0; // Is a super admin
$flags['owner']  = 0; // Is owner
$flags['rank']   = 0; // (0-9)

// Admin rank numbers
define ('RANK_MOD',    4);
define ('RANK_ADMIN',  5);
define ('RANK_SADMIN', 7);
define ('RANK_OWNER',  9);

// Mailbox
$mail_status = array();
$mail_status['new']     = 0;
$mail_status['unread']  = 1;
$mail_status['read']    = 2;
$mail_status['replied'] = 3;

// Cookies
$cookie_life = 5184000; // in seconds

// ===================================================================
// Includes
//
$debug = 0;
$cookie_path = '';
if (!@include ('dbconn.php')) {
	if (!file_exists ('dbconn.php')) {
		echo "<html>\n<body>\n<p>Click here to <a href=\"install.php\">run the installer</a>.</p>\n</body>\n</html>";
		exit;
	} else {
		exit ('Cannot open database file!');
	}
}

$cfg = array();
if (!@include ('config.php')) {
	exit ('Cannot open config file!');
} else {
	if ($cfg['version'] != $cfg_ver_check) {
		exit ("<html>\n<body>\n<p>Please run the <a href=\"update.php\">updater</a>.</p>\n<p>Config required: v{$cfg_ver_check}<br />Config present: v{$cfg['version']}</p>\n</body>\n</html>");
	}
}


require ('common.php');


// ===================================================================
// Init
//
//$db = $OekakiPoteto_Prefix;
//$dbm = $OekakiPoteto_MemberPrefix;
$start_time = get_microtime();

// User info.  OekakiU should not have slashes, but just in case...
$OekakiU    = addslashes (stripslashes ($OekakiU));
$OekakiPass = addslashes (stripslashes ($OekakiPass));
$language = $cfg['language'];
$template = $cfg['template'];
$cssinclude    = ''; // Path for HTML style tag
$template_name = '';

// Picture and thumbnail logic
$p_pic = $cfg['op_pics'].'/'.$cfg['op_pre'];
$t_pic = $cfg['op_pics'].'/'.$cfg['op_pre'].'t';
$r_pic = $cfg['op_pics'].'/'.$cfg['op_pre'].'r';
$p_prefix = $cfg['op_pre'];
$t_prefix = $cfg['op_pre'].'t';
$r_prefix = $cfg['op_pre'].'r';


// ===================================================================
// Hacks! (requires config)
// Included here since boot.php is used on EVERY page, and hacks may be security/user related
//
if (file_exists ($cfg['res_path'].'/'.'hacks.php')) {
	define ('HACK_CHECK', 1); // Version control
	include ($cfg['res_path'].'/'.'hacks.php');
}


// ===================================================================
// Ban list
// BAN_OVERRIDE is for hacks, BAN_KILL is internal use only
//
// Get IP and hostname
$address = 'invalid';
$hostname = 'invalid';
if (!empty ($_SERVER['REMOTE_ADDR'])) {
	$address = $_SERVER['REMOTE_ADDR'];
	$hostname = @gethostbyaddr ($_SERVER['REMOTE_ADDR']);
}

if (BAN_OVERRIDE != 1 && BAN_KILL != 1) {
	// !hacks.php
	require ('banscript.php');
}


// ===================================================================
// Registered users only
//
if (!empty ($OekakiU)) {
	$result = mysql_query ("SELECT * FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$OekakiU'");

	if ($result) {
		if (mysql_num_rows ($result)) {
			$user = @mysql_fetch_array ($result);

			// Verify password
			if ($OekakiPass == $user['usrpass']) {
				// Verify active (non-pending)
				if (strstr ($user['usrflags'], 'G') && !strstr ($user['usrflags'], 'P')) {
					// Note: pending members should not have cookies!
					$flags['member'] = 1;
				}
			}
		}
	} else {
		if (!$quiet_mode) {
			// It's serious to have SQL bomb here.  DIE!
			error_log (__FILE__.'; User='.$OekakiU.'; DB: '.mysql_error());
			exit ('Login failed due to a server error.  If the problem persists, ask the admin to check the server log.');
		}
		// Flush for quiet mode
		$user = array();
		$flags = array();
	}


	//
	// If SQL works and registration checks out
	//
	if ($flags['member']) {
		//
		// Get flags
		//
		$usrflags = $user['usrflags'];
		$flags['all'] = $usrflags;

		// Assign each flag as a key in $flags array
		$len = strlen ($usrflags);
		for ($i = 0; $i < $len; $i++) {
			$chr = $usrflags[$i];
			$flags[$chr] = $chr;
		}
		unset ($usrflags);


		// Get admin flags
		$flags['rank'] = (int) $user['rank'];
		if ($flags['rank'] >= RANK_MOD)    $flags['mod']    = 1;
		if ($flags['rank'] >= RANK_ADMIN)  $flags['admin']  = 1;
		if ($flags['rank'] >= RANK_SADMIN) $flags['sadmin'] = 1;
		if ($flags['rank'] >= RANK_OWNER)  $flags['owner']  = 1;


		//
		// Get language, template
		// Blank for either means use default
		//
		if (!empty ($user['language'])) {
			$language = $user['language'];
		}
		if (!empty ($user['templatesel'])) {
			$template = $user['templatesel'];
		}


		//
		// Update last login
		//
		$result = @mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET lastlogin=NOW() WHERE usrname='$OekakiU'");

	} else {
		// Password didn't match up!  Clear user info
		$OekakiU = '';
		$OekakiPass = '';
		$user = array();
		$flags = array();

		if (!$quiet_mode) {
			if ($debug) {
				echo 'Cookie Reset';
			} else {
				setcookie ('OekakiU', '', time() - $cookie_life, $cookie_path);
				setcookie ('OekakiPass', '', time() - $cookie_life, $cookie_path);
			}
		}

		// Note: don't redirect here, or an infinate loop may result.
	}
}


// ===================================================================
// If registered or non-registered
//

// Check for quiet mode.
if (!$quiet_mode) {

	// Import main language, niftytoo
	//
	include ('language/'.$language.'.php');
	require ('niftytoo.php');


	// Build and set template
	//
	$template_name = $template;
	$template_file = $cfg['tpl_path'].'/'.$template;

	if (!$no_template) {
		$cssinclude = $template_file.'.css';

		//Use built CSS, otherwise build+use CSS, otherwise use default.
		if (file_exists ($template_file.'.css') && !$force_build) {
			$cssinclude = $template_file.'.css';
		} else {
			if (file_exists ($template_file.'.php')) {
				if (!is_writable ($cfg['tpl_path'])) {
					@mysql_close ($dbconn);
					exit ('Templates folder is locked!  Folder must be CHMOD to 755 (preferred) or 777.  View Readme.txt for help.');
				}

				// Build CSS
				$tcontrol = 'build';
				ob_start();
				include($template_file.'.php');
				$cssdata = ob_get_contents();
				if (!empty ($cssdata) && $handle = @fopen ($template_file.'.css', 'w')) {
					fwrite ($handle, $cssdata);
					fclose ($handle);
				} else {
					// CSS problem! Use default
					$cssinclude = $cfg['tpl_path'].'/'.$template.'.css';
					$template_name = $template;

					if (!file_exists($cssinclude)) {
						// Mega problem!
						$cssinclude = $cfg['tpl_path'].'/Default.css';
						$template_name = 'Failsafe';
					}
				}
				ob_clean();
				unset ($tcontrol);
			}
		}
	} // End template build


	// Set layout, thumbnail
	//
	if ($flags['member']) {
		$display = $user['picview'];
		$screensize = $user['screensize'];

		if ($cfg['force_thumb'] == 'yes' || $user['thumbview'] == 0) {
			$thumbDisplay = $cfg['use_thumb'];
		} else {
			$thumbDisplay = $user['thumbview'];
		}

		// Account "Screenshot" disables thumbnails
		if ($OekakiU == 'Screenshot') {
			$thumbDisplay = 0;
		}
	} else {
		$display = 0;
		$screensize = 800;
		$thumbDisplay = $cfg['use_thumb'];
	}


	// ===================================================================
	// Check installer, updater.  For effiency and to resolve conflicts
	// with non-installed boards, check for admin cookies only.
	//
	if ($action == 'secure') {
		@unlink('install.php');
		@unlink('update.php');
	}
	if ($flags['admin']) {
		if (file_exists ('install.php') || file_exists ('update.php')) {
			exit ("<html>\n<body>\n<p>&ldquo;install.php&rdquo; and/or &ldquo;update.php&rdquo; still exists!</p>\nIf you do not need them anymore, <a href=\"index.php?action=secure\">click here to remove them</a>.</p>\n<p>If you get this error again, delete the files manually via FTP.</p>\n</body>\n</html>");
		}
	}


	// ===================================================================
	// Online
	//
	if (!$no_online) {
		if (!empty ($_SERVER['PHP_SELF'])) {
			// Fixes servers using PHP as a runtime and not as a module
			$my_script = $_SERVER['PHP_SELF'];
		} else {
			$my_script = $SCRIPT_NAME;
		}

		$loc = 'View';
		if (strstr ($my_script, 'chat')) {
			$loc = 'chat';
		} else {
			// Maintenance
			$online = mysql_query('DELETE FROM '.$OekakiPoteto_MemberPrefix.'oekakionline WHERE (DATE_ADD(onlinetime, INTERVAL 15 MINUTE) < NOW())');

			$online = mysql_query('DELETE FROM '.$OekakiPoteto_MemberPrefix.'oekakionline WHERE (DATE_ADD(onlinetime, INTERVAL 1 MINUTE) < NOW()) AND locale=\'chat\'');
		}

		if ($flags['member'] && !empty ($OekakiU)) {
			// User is on OekakiPoteto; check if present on table
			$online = mysql_query("UPDATE {$OekakiPoteto_MemberPrefix}oekakionline SET onlinetime=NOW(), locale='$loc', onlineboard='".addslashes($cfg['op_title'])."' WHERE onlineusr='$OekakiU'");

			if (!mysql_affected_rows()) {
				$online = mysql_query("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakionline SET onlineusr='$OekakiU', onlinetime=NOW(), onlineIP='$address', locale='$loc', onlineboard='".addslashes($cfg['op_title'])."'");
			}
		}
	} // End Online

} // End quiet mode

?>